;TIP1191.LSP:   ARCLEN.LSP    Quick Arc Length     (c)1996, Michael Wolff

; A quick little routine to measure the actual length of an arc or a line.
; The routine then places the measurement a specified distance above or
; the selected entity.
; text height is currently set to 
; 0.125 * dimscale factor, modify to suit.

(DEFUN C:AL (/ ARC BSPT PT RAD PL VT PTA VT1 DIST ANG LEN STR RAD 
  AN AN1 YN EN ENT ENAM ENAME OSM CMD ORM TXTHT)
  (if (= 1 (getvar "GRIDMODE") ) (setvar "GRIDMODE" 0) )
  (setq OLD_ERR *error*
    *error* NEW_ERR
    OSM (getvar "OSMODE")
    CMD (getvar "CMDECHO")
    ORM (getvar "ORTHOMODE")
  ) ;setq
  (setvar "CMDECHO" 0)
  (setvar "ORTHOMODE" 0)
  (setvar "OSMODE" 0)
  (setq TXTHT (* (getvar "DIMSCALE") 0.125)) ;;modify text height to suit
  (if (/= 0.0 (cdr (assoc 40 (tblsearch "style" (getvar "TEXTSTYLE")))))
    (command "style" "" "" 0 "" 0 "" "" "")
  )
  (sel) ;Select entity routine
  (fin) ;Set system variables the way I found 'em
);defun

(defun sel()
  (setq ARC nil)
  (while (not ARC)
  (setq ARC (entsel "\nSelect arc or line :")))
  (setq BSPT (cadr ARC)
    EN (entget (car ARC))
  ENT (cdr (assoc 0 EN)))
  (cond 
    ( (= "LINE" ENT) (LIN) )
    ( (= "ARC" ENT) (ARK) )
    (t 
      (progn
        (alert "Not a line or an arc")
        (sel)
      )
    )
  )
)

(defun ark()
  (setq RAD (cdr (assoc 40 EN)))
  (setvar "LASTPOINT" (cdr (assoc 10 EN)))
  (command "id" (strcat "@" (rtos RAD) "<"
      (angtos (/ (+ (cdr (assoc 50 EN))
  (cdr (assoc 51 EN))) 2)0 4)))
  (setq BSPT (getvar "LASTPOINT"))
  (command "pedit" BSPT "" "X")
  (setq PL (entget (entlast))        ;Procedure to get arc endpoints
    VT (entget (entnext (cdr (assoc -1 PL))))
    PT (cdr (assoc 10 VT))
    VT1 (entget (entnext (cdr (assoc -1 VT))))
  PTA (cdr (assoc 10 VT1)))
  (command "explode" (cdr (assoc -1 PL))) ;Put arc back the way I found it
  (setq EN (cdr (assoc -1 (entget (entlast))))) ;Get arc
  (setq DIST (distance PT PTA));Get dist between arc endpoints
  (setq ANG (* 2.0 (atan       ;get included angle
        (/ DIST 2.0
          (sqrt (- (expt RAD 2)
    (expt (/ DIST 2.0)2))))))
    LEN (* RAD ANG) ;get arc length
    STR (rtos LEN 2 2) 
    RAD (strcat "R=" (rtos RAD 2 2))
    DEF_AN (rtos (* (angle PT PTA) (/ 180 pi)) 2 2)
    PT1 (list (/ (+ (car PT) (car PTA) ) 2)
      (/ (+ (cadr PT) (cadr PTA) ) 2)
    ) ;Builds a point list for visual center of arc 
  ) ; setqs
  (initget "Yes No")
  (setq YN (getkword "\nInclude Radius ? Yes/No <N>: "))
  (if (= YN "Yes")
    (progn
      (setq AN (getangle PT1 (strcat 
      "\nEnter angle for arc length text " STR " < "def_an" > : ")))
      (defang)
      (command "text" "c" BSPT TXTHT AN STR)
      (getlast);get last entity
      (setq ENAME ENAM);Save for redraw later
      (ofs) ;Subroutine to move text off line.
      (setq AN1 (getangle PT1
      (strcat "\nEnter angle for radius text " RAD " < " AN " >: ")))
      (if (= AN1 nil) ;Was default angle used ?
        (setq AN1 AN) 
        (setq AN1 (angtos an1 0 2))
      );if
      (command "text" "c" BSPT TXTHT AN1 RAD)
      (getlast)  ;get last entity
      (ofs)  ;offset routine
    );progn
    (progn
      (setq AN (getangle PT1 (strcat
      "\nEnter angle for arc length text " STR " < " DEF_AN " > : ")))
      (defang)  ;default angle routine
      (command "text" "c" BSPT TXTHT AN STR)
      (getlast)  ;get last entity
      (ofs)  ;offset routine
    );progn
  );if
)
;;;;end arc routine

(defun lin()
  (Prompt "\nSelected entity is a LINE...")
  (setq PT (cdr (assoc 10 EN))
    PTA (cdr (assoc 11 en))
    DEF_AN (rtos (* (angle PT PTA) (/ 180 pi)) 2 2)  ;Get line angle
    EN (cdr (assoc -1 EN))
    DIST (distance PT PTA);Get line length
    PT1 (list (/ (+ (car PT) (car PTA) ) 2)  ;Center of line
      (/ (+ (cadr PT) (cadr PTA) ) 2)
    )
  )
  (setq STR (rtos DIST 2 2))
  (setq AN (getangle pt1 
  (strcat "\nEnter angle for line text " STR " <" DEF_AN "> : ")))
  (defang)
  (command "text" "c" PT1 TXTHT AN STR)
  (getlast)  ;get last entity
  (ofs)  ;offset routine
  (princ)
)

(defun defang()   
  (if (= AN Nil) ;Was default angle used ?
    (setq AN def_an)
    (setq AN (angtos an 0 2))
  );if
)

(defun getlast()
  (setq TXT (entget (entlast))
  ENAM (cdr (assoc -1 TXT)))
)

(defun ofs()
  (setq PT (cdr (assoc 11 TXT)))
  (if (= ENT "ARC")
    (setq PTA BSPT)
    (setq PTA PT1)
  )
  (if (= POS nil) (setq POS "Above") )
  (cond                                   ;If the radius is to be included
    ( (and (= YN "Yes") (= POS "Above") ) ;then switch the default position
      (setq POS "Below")             ;so the radius & length are on
    )                                     ;either side of line by default.
    ( (and (= YN "Yes") (= POS "Below") )
      (setq POS "Above")
    )
    (t nil)
  );cond
  (initget "Above Below")
  (setq TB (getkword (strcat "\nAbove or Below line < "pos" > ? ")))
  (if (= TB nil) (setq TB POS))   ;Was default used
  (setq POS TB)
  (cond
    ( (= TB "Above") (top) )
    ( (= TB "Below") (bot) )
    (T nil)
  )
)

(defun top()
  (command "ucs" "e" ENAM)
  (command "move" "si" enam (trans PT 0 1) (trans PTA 0 1) )
  (command "move" "si" "p" "@" "@5<90")
  (command "ucs" "w")
  (redraw EN 1)
  (if ENAME (redraw ENAME 1))
)

(defun bot()
  (command "ucs" "e" ENAM)
  (command "move" "si" ENAM (trans PT 0 1) (trans PTA 0 1) )
  (command "move" "si" "p" "@" "@15<270")
  (command "ucs" "w")
  (redraw EN 1)
  (if ENAME (redraw ENAME 1))
)


(defun new_err(msg)
  (if (= MSG "quit / exit abort")
    (princ)
    (princ (strcat "\nError: " MSG))
  )
  (princ)
  (fin)
)

(defun fin()  
  (setq *error* OLD_ERR)
  (setvar "CMDECHO" CMD)
  (setvar "OSMODE" OSM)
  (setvar "ORTHOMODE" ORM)
  (princ)
)
(princ); end arclen.lsp
