;TIP1195.LSP:   FLEX.LSP    Flexible Duct    (c)1996, Don Levine

; NOTE: "Dimscale" must be set accordingly in order for the 
;       program to function properly. 

(defun C:FLEX (/ CV DIMSC SF SP1 SP2 SP3 DISTR 
  DISTN ANG PO4 L1 L2 AT2 QDST NUM 
  P1 P2 P3 P4 PT1 PT2 FP) 
  (setq CV 0)
  (command "ortho" "on")
  (setq DIMSC (getvar "dimscale")) ;scaling is based on dimscale
  (setq SF (/ DIMSC 96.0)) 
  (setq SP1 nil)
  (while (not SP1)
    (setq sp1 (getpoint "\nPlease indicate center of diffuser: "))
    (if (not SP1)
      (progn       ;activate snaps by pressing enter
        (command "osnap" "int,cen,mid")
        (setq SP1 (getpoint "\nIntersection-center-midpoint of?: "))
        (command "osnap" "none")
      )
    )
  )
  (setq SP2 nil)
  (while (not SP2)
    (setq SP2 (getpoint "\nIndicate first run of flex: " SP1))
  )
  (command "line" SP1 SP2 "")
  (command "ortho" "off")
  (while (= CV 0)
    (while (not SP3)
      (setq SP3 (getpoint "\nIndicate main run of flex: " SP2))
      (if (< (distance SP2 SP3) (* 10.0 SF)) 
        (progn
          (princ "\nLonger run please... : ")
          (setq SP3 nil)
        )
        (setq CV 1)
      )
    )
  )
  (setq DISTO (distance SP2 SP3))
  (setq DISTN (- DISTO (* SF 8.0)))
  (setq ANG (angle SP2 SP3))
  (setq PO4 (atan 2.0))
  (setq L1 (* SF (sqrt 20.0)))
  (setq L2 (* SF (sqrt 68.0))) 
  (setq AT2 (atan 4.0))
  (setq QDST (/ DISTN (* 4.0 SF)));
  (setq NUM (fix QDST))
  (setq P1 (polar SP2 ang (* SF 1.0)))
  (setq P2 (polar P1 (+ po4 ANG) L1))
  (setq P3 (polar P2 (- ang AT2) L2))
  (command "line" SP2 P1 P2  P3 "")
  (while (> NUM 0.0)
    (setq PT1 (polar P3 (+ ANG AT2) L2))
    (setq PT2 (polar PT1 (- ANG AT2) L2))
    (command "line" P3 PT1 PT2 "")
    (setq P3 (polar P3 ANG (* SF 4.0)))
    (setq NUM (- NUM 1))
  )
  (setq p4C (polar P3 (+ ANG PO4) L1))
  (command "line" P3 P4 "")
  (command "line" P4 SP3 "")
  (command "ortho" "on")
  (setq FP nil)
  (while (not FP)
    (setq FP (getpoint "\nLocate final run on ductwork: " SP3))
  )
  (command "line" SP3 FP "")
  (prin1)
); end flex.lsp
