;TIP1198.LSP:   SPIN.LSP   Spin Around a Model   (c)1996, Eric Loeschner

;; The directory for the slides must exist
;; revise the name to suit.

; mslide function
(defun mspin ()
  (prompt "\nMake a slideshow.")
  (setq N 1)
  (setq CEN (getpoint "\nCenter point <0,0,0>: "))
  (if (= CEN nil) (setq CEN (list 0 0 0)))
  (setq BAG (getreal "\nBeginning angle in degrees <270>: "))
  (if (= BAG nil) (setq BAG 270.0))
  (setq EVA (getstring "\nElevation angle in degrees <30>: "))
  (if (= EVA "") (setq EVA "30"))
  (setq DIS (getstring "\nViewing distance <10>: "))
  (if (= DIS "") (setq DIS "10"))
  (if (= (getvar "USERI1") 0)
    (setvar "USERI1" 6.0)
  )
  (setq SPR (getint (strcat "\nSlides per revolution <"
  (rtos (getvar "USERI1") 2 0) ">: ")))
  (if (= SPR nil) 
    (setq SPR (getvar "USERI1"))
    (setvar "USERI1" SPR)
  )
  (setq INC (/ 360.0 SPR))
  (setq HSW (getstring 
  "\nHidden lines removed (H), Shaded (S) or Wireframe <W>: "))
  (if (and (/= (strcase HSW) "H") (/= (strcase HSW) "S")) 
    (setq HSW "W")
  )
  (setq TIM (getvar "TILEMODE")) (setvar "TILEMODE" 1)
  (command "plan" "" "zoom" "a" "select" "c" (getvar "VSMIN") 
  (getvar "VSMAX") "")

  (setq NAME  (getvar "DWGNAME"))
  (setq PREFIX (getvar "DWGPREFIX"))
  (setq LEN (strlen PREFIX))
  (setq NAME4 (substr NAME (+ LEN 1) 4))

  (while (<= N SPR) 
    (command "dview" "p" "" "po" CEN
      (strcat "@" DIS "<" (rtos (+ BAG (* N INC)) 2 0) "<" EVA)
      "D" DIS "X" 
      (if (= (strcase HSW) "H") "HIDE") (if (= (strcase HSW) "S") "SHADE")
      "mslide" 
      (strcat "c:/0hth_try/" NAME4
        ;;modify path above to suit
      (rtos (fix N) 2 0) ".sld")
    )                
    (setq N (1+ N))
  )
  (setvar "TILEMODE" TIM)
); end mspin

; vslide function
(defun vspin ()
  (prompt "\nView a slideshow.")
  (setq N 1 M 1 SPR (getvar "USERI1"))
  (setq DEL (getreal "\nFrame delay in seconds <0>: "))
  (if (= DEL nil) (setq DEL 0))
  (setq REV (getreal "\nNumber of revolutions <1>: "))
  (if (= REV nil) (setq REV 1.0))
  (setq DEM (* DEL 1000))

  (setq NAME  (getvar "DWGNAME"))
  (setq PREFIX (getvar "DWGPREFIX"))
  (setq LEN (strlen PREFIX))
  (setq NAME4 (substr NAME (+ LEN 1) 4))

  (while (<= M REV)    
    (while (<= N SPR) 
      (command "vslide" 
      (strcat "*c:/0hth_try/"  NAME4
          ;;modify path above to suit
      (rtos N 2 0) ".sld")
      "delay" (fix dem) "VSLIDE"
      )
      (setq N (1+ N))
    )
    (setq N 1) (setq M (1+ M))
  )
); end vspin

(defun C:SPIN ()
  (prompt "\nSpins model by revolving a camera about a y-axis.")
  (setq FUN (getstring "\nMake a slideshow <M> or view one (V): "))
  (command "view" "s" "temp")
  (setq OSM (getvar "OSMODE")) (setvar "OSMODE" 0)
  (setq LUP (getvar "LUPREC")) (setvar "LUPREC" 0)
  (setq AUN (getvar "AUNITS")) (setvar "AUNITS" 0)
  (if (/= (strcase FUN) "V") (mspin) (vspin))
  (setvar "AUNITS" AUN)
  (setvar "LUPREC" LUP)
  (setvar "OSMODE" OSM)
  (command "view" "r" "temp")
  (prin1)
); end spin.lsp
