;TIP1200.LSP:   XLINES.LSP   Construction Lines   (c)1996, Bill Bratt

(defun C:VER (/ PT Y PNT X)
  (START)
  (prompt "\n*** OSNAP is set at INTersection ****")
  (setvar "osmode" 32 ) 
  (setq PT (getpoint 
  "\nPick point along y-axis to project lines to: \n\n"))
  (setq Y (cadr PT))
  (setvar "orthomode" 1)             ;Ortho on
  (command "layer" "make" "0-constr-line-6" "c" "6" "" "")
  (setq D "T")
  (while D
    (setq PNT (getpoint 
    "\nPick starting point for line to project (ctrl-C to cancel): \n\n"))
    (setq X (car PNT))
    (setvar "osmode" 0 ) 
    (command "line"  PNT (list X Y) "")
    (setvar "osmode" 32 ) 
  ) ; end of while
  (princ)
  (end)
) ; end of function
;****************************************
(defun C:HOR (/ PT Y PNT X)
  (START)
  (prompt "\n**** OSNAP is set at INTersection ****")
  (setvar "osmode" 32 ) 
  (setq PT (getpoint 
  "\nPick point along x-axis to project lines to: \n\n"))
  (setq X (car PT))
  (setvar "orthomode" 1)             ;Ortho on
  (command "layer" "make" "0-constr-line-6" "c" "6" "" "")
  (setq D "T")
  (while D
    (setq PNT (getpoint  
    "\nPick starting point for line to project (ctrl-C to cancel): \n\n"))
    (setq Y (cadr PNT))
    (setvar "osmode" 0 ) 
    (command "line"  PNT (list X Y) "")
    (setvar "osmode" 32 ) 
  ) ; end of while
  (princ)
  (end)
) ; end of function

;**********************************************
;               ERROR FUNCTION 
;**********************************************
; Function resets beginning values if an error occurs or (ctrl-C).
(defun *error* (msg)
  (if (/= MSG "Function cancelled")
    (princ (strcat "\nAutoLISP Error:  " MSG))
    (terpri)
  )
  (END)
  (princ)
)  
;*******************************************
;            START FUNCTION 
;********************************************
(defun START ()
  (setq OLDERR *error*)
  (setq S_CMD (getvar "cmdecho"))
  (setvar "cmdecho" 0)
  (setq S_OSM (getvar "osmode"))
  (setvar "osmode" 0)   ; NONE
  (setq S_BLIP (getvar "blipmode"))
  (setvar "blipmode" 0)
  (setq S_ORTH (getvar "orthomode"))
  (setvar "orthomode" 0)             ;Ortho off
  (graphscr)
  (setq CL (getvar "clayer"))
)   ;end of START function
;*******************************************
;             END FUNCTION 
;********************************************
(defun END ()
  (setvar "blipmode" S_BLIP)
  (setvar "orthomode" S_ORTH)
  (setvar "osmode" S_OSM)
  (command "layer" "s" CL "")
  (setq *error* OLDERR)
  (setvar "cmdecho" S_CMD)
  (prompt "\nType: VER for vertical construction lines.")
  (prompt "\nType: HOR for vertical construction lines.")
  (princ)
)   ; end of END function
;**********************************************
(prompt "\nType: VER for vertical construction lines.")
(prompt "\nType: HOR for vertical construction lines.")
(princ); end xines.lsp


